import 'package:flutter/widgets.dart';
import 'package:microfrontends/microfrontends.dart';

import 'state.dart';

class NavBinding extends Binding<NavState> {
  final String initialPage;
  final List<String> pages;

  NavBinding({
    required Widget child,
    required this.initialPage,
    required this.pages,
  }) : super(child: child);

  @override
  StateContainer<NavState> create(BuildContext context) {
    return container<NavState>(
      NavState(initialPage, pages),
    )
      ..query<ActivePage>((ctrl, state, params) => ActivePage(state.activePage))
      ..query<List<String>>((ctrl, state, params) => state.pages)
      ..mutation<SetActivePage>(
        (ctrl, state, mutation) => NavState(mutation!.payload, state.pages),
      );
  }
}
